var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { Switch } from 'react-router-dom';
import PropTypes from 'prop-types';

import * as routeHelpers from './helpers';
import LayerIdContext from "./LayerIdContext";

var LayerManager = function (_Component) {
    _inherits(LayerManager, _Component);

    function LayerManager(props) {
        _classCallCheck(this, LayerManager);

        var _this = _possibleConstructorReturn(this, (LayerManager.__proto__ || Object.getPrototypeOf(LayerManager)).call(this, props));

        _this.state = {
            pages: []
        };
        return _this;
    }

    _createClass(LayerManager, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(props) {
            return !routeHelpers.equalLocations(props.location, this.props.location);
        }
    }, {
        key: 'UNSAFE_componentWillMount',
        value: function UNSAFE_componentWillMount() {
            var _props = this.props,
                layerId = _props.layerId,
                routes = _props.routes,
                onCloseLayer = _props.onCloseLayer,
                routeWrappers = _props.routeWrappers;


            var pages = routes.map(function (route) {
                return routeHelpers.generateRouteComponent({
                    props: _extends({}, route, { layerId: layerId, onCloseLayer: onCloseLayer }),
                    routeId: route.routeId,
                    routeWrappers: routeWrappers
                });
            });

            this.setState({ pages: pages });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                location = _props2.location,
                withLayerIdContext = _props2.withLayerIdContext,
                layerId = _props2.layerId;
            var pages = this.state.pages;


            if (withLayerIdContext) {
                return React.createElement(
                    LayerIdContext.Provider,
                    { value: layerId },
                    React.createElement(
                        Switch,
                        { location: location },
                        pages
                    )
                );
            }

            return React.createElement(
                Switch,
                { location: location },
                pages
            );
        }
    }]);

    return LayerManager;
}(Component);

LayerManager.propTypes = {
    routes: PropTypes.array.isRequired, //роуты слоев
    layerId: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    location: PropTypes.object.isRequired,
    onCloseLayer: PropTypes.func.isRequired,
    routeWrappers: PropTypes.arrayOf(PropTypes.func),
    withLayerIdContext: PropTypes.bool
};
export { LayerManager as default };