var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import { withRouter } from 'react-router';
import PropTypes from 'prop-types';

import LoadingComponent from './LoadingComponent';
import ErrorBoundary from './ErrorBoundary';
import RouteManager from './RouteManager';
import * as routeHelpers from './helpers';
import LayerIdContext from './LayerIdContext';

var _default = withRouter(_class = function (_React$Component) {
    _inherits(_default, _React$Component);

    function _default(props, context) {
        _classCallCheck(this, _default);

        var _this = _possibleConstructorReturn(this, (_default.__proto__ || Object.getPrototypeOf(_default)).call(this, props, context));

        _this.state = {
            allRoutes: routeHelpers.transformRoutes(props.routes, props.defaultLayout, props.defaultLayerLayout)
        };
        return _this;
    }

    _createClass(_default, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                notFound = _props.notFound,
                location = _props.location,
                history = _props.history,
                routeWrappers = _props.routeWrappers,
                loadingComponent = _props.loadingComponent,
                errorBoundary = _props.errorBoundary,
                withLayerIdContext = _props.withLayerIdContext,
                layersLimit = _props.layersLimit;


            return React.createElement(RouteManager, {
                history: history,
                location: location,
                routeWrappers: routeWrappers,
                routes: this.state.allRoutes,
                loadingComponent: loadingComponent,
                errorBoundary: errorBoundary,
                notFound: notFound,
                withLayerIdContext: withLayerIdContext,
                layersLimit: layersLimit
            });
        }
    }]);

    return _default;
}(React.Component)) || _class;

_default.propTypes = {
    routes: PropTypes.array.isRequired,
    notFound: PropTypes.func,
    defaultLayout: PropTypes.func,
    defaultLayerLayout: PropTypes.func,
    loadingComponent: PropTypes.func,
    errorBoundary: PropTypes.func,
    routeWrappers: PropTypes.arrayOf(PropTypes.func),
    withLayerIdContext: PropTypes.bool,
    layersLimit: PropTypes.number
};
_default.defaultProps = {
    loadingComponent: LoadingComponent,
    errorBoundary: ErrorBoundary,
    withLayerIdContext: false
};
export { _default as default };


export { LayerIdContext };